
Redmine - Patch #23269
Description

When starting up Redmine in development mode and accessing the /time_entries/report page on the first request, Redmine in at

least versions 3.3 and trunk fails to properly autoload the Version class.

The full error is:

Unable to autoload constant Redmine::Version, expected lib/redmine/version.rb to define it

activesupport (4.2.6) lib/active_support/dependencies.rb:495:in `load_missing_constant'

activesupport (4.2.6) lib/active_support/dependencies.rb:184:in `const_missing'

activesupport (4.2.6) lib/active_support/dependencies.rb:526:in `load_missing_constant'

activesupport (4.2.6) lib/active_support/dependencies.rb:184:in `const_missing'

activesupport (4.2.6) lib/active_support/dependencies.rb:526:in `load_missing_constant'

activesupport (4.2.6) lib/active_support/dependencies.rb:184:in `const_missing'

lib/redmine/helpers/time_report.rb:111:in `load_available_criteria'

lib/redmine/helpers/time_report.rb:39:in `available_criteria'

app/views/timelog/report.html.erb:23:in `block in _app_views_timelog_report_html_erb___33300578724

28091759_70181945143200'

 The reason for this is that the lookup happens inside the class Redmine::Helpers::TimeReport and the Version model class is not

loaded yet. Thus, the Rails autoloader tries to load the class and navigates up the module chain. It finds a file matching the naming

conventions in lib/redmine/version.rb which would match the expected module/class Redmine::Version which in turn would have

precedence before ::Version in the lookup chain.

Since lib/redmine/version.rb does not define Redmine::Version, the error occurs. A fix to this is to fully qualify the class on lookup to

give the autoloader a hint where to look at. The attached patch fixes this.

Note that this issue doesn't seem to occur in production mode.

Associated revisions

Revision 15645 - 2016-07-12 21:45 - Jean-Philippe Lang

Fully qualify the Version class in Redmine::Helpers::TimeReport (#23269).

Patch by Holger Just.

Revision 15745 - 2016-08-20 13:54 - Jean-Philippe Lang

Merged r15645 (#23269).

Revision 15746 - 2016-08-20 13:55 - Jean-Philippe Lang

Merged r15645 (#23269).

History

#1 - 2016-07-12 21:45 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 3.2.4

Committed, thanks.
#2 - 2016-08-20 13:55 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

0001-Fully-qualify-the-Version-class-in-Redmine-Helpers-T.patch 1.15 KB 2016-07-07 Holger Just

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

